=== debian/changelog ===
libopenshot (0.2.4+dfsg1-0.1~mx17+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Bump to debhelper compat 11.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 20 Feb 2020 14:57:31 -0800

libopenshot (0.2.4+dfsg2+857+202002101802+daily~ubuntu18.04.1) bionic; urgency=low

  * Auto build.

 -- OpenShot Code <openshot.code@lists.launchpad.net>  Mon, 10 Feb 2020 18:02:06 +0000

libopenshot (0.2.4-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Sat, 08 Feb 2020 18:54:11 -0600

libopenshot (0.2.3-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Wed, 20 Mar 2019 20:47:26 -0500

libopenshot (0.2.1-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Wed, 19 Sep 2018 00:26:01 -0500
