=== debian/control ===
Source: libopenshot
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper (>= 11),
               dh-python,
               dpkg-dev (>= 1.17.14),
               ffmpeg,
               libavcodec-dev,
               libavdevice-dev,
               libavformat-dev,
               libavresample-dev,
               libavutil-dev,
               libjsoncpp-dev,
               libmagick++-6.q16-dev,
               libopenshot-audio-dev (>= 0.1.9),
               libswscale-dev,
               libunittest++-dev,
               libzmq3-dev,
               pkg-config,
               python3-dev,
               qtbase5-dev,
               qtmultimedia5-dev,
               swig
Build-Depends-Indep: doxygen
Standards-Version: 3.9.6
Homepage: http://www.openshot.org/

Package: libopenshot18
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Replaces: libopenshot17,
          libopenshot16,
          libopenshot15,
          libopenshot14,
          libopenshot13,
          libopenshot12,
          libopenshot11
Description: library for high quality video editing
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the OpenShot library.

Package: libopenshot-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libopenshot18 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libopenshot-doc
Description: development files for the OpenShot library
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the development files for the OpenShot library.

Package: libopenshot-doc
Architecture: all
Section: doc
Depends: libjs-jquery,
         ${misc:Depends}
Description: documentation of the OpenShot library
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the documentation for the OpenShot library.

Package: python3-openshot
Architecture: any
Multi-Arch: same
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python bindings for the OpenShot library
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the Python bindings for the OpenShot library.
